<?php

function cek_terakhir($datetime, $full = false) {
    $today = time();
    $createdday = strtotime($datetime);
    $datediff = abs($today - $createdday);
    $difftext = "";
    $years = floor($datediff / (365 * 60 * 60 * 24));
    $months = floor(($datediff - $years * 365 * 60 * 60 * 24) / (30 * 60 * 60 * 24));
    $days = floor(($datediff - $years * 365 * 60 * 60 * 24 - $months * 30 * 60 * 60 * 24) / (60 * 60 * 24));
    $hours = floor($datediff / 3600);
    $minutes = floor($datediff / 60);
    $seconds = floor($datediff);
    //year checker  
    if ($difftext == "") {
        if ($years > 1)
            $difftext = $years . " Tahun Lalu";
        elseif ($years == 1)
            $difftext = $years . " Tahun Lalu";
    }
    //month checker  
    if ($difftext == "") {
        if ($months > 1)
            $difftext = $months . " Bulan Lalu";
        elseif ($months == 1)
            $difftext = $months . " Bulan Lalu";
    }
    //month checker  
    if ($difftext == "") {
        if ($days > 1)
            $difftext = $days . " Hari Lalu";
        elseif ($days == 1)
            $difftext = $days . " Hari Lalu";
    }
    //hour checker  
    if ($difftext == "") {
        if ($hours > 1)
            $difftext = $hours . " Jam Lalu";
        elseif ($hours == 1)
            $difftext = $hours . " Jam Lalu";
    }
    //minutes checker  
    if ($difftext == "") {
        if ($minutes > 1)
            $difftext = $minutes . " Menit Lalu";
        elseif ($minutes == 1)
            $difftext = $minutes . " Menit Lalu";
    }
    //seconds checker  
    if ($difftext == "") {
        if ($seconds > 1)
            $difftext = $seconds . " Detik Lalu";
        elseif ($seconds == 1)
            $difftext = $seconds . " Detik Lalu";
    }
    return $difftext;
}
?>

<div class="col-md-12">
    <div class="box box-primary panel panel-primary collapsed-box">
        <div class="box-header">
            <i class="fa fa-history"></i>
            <h3 class="box-title">Daftar Riwayat Login User</h3>
            <div class="box-tools pull-right">
                <button class="btn btn-box-tool" data-widget="collapse" data-toggle="tooltip" title="Collapse"><i class="fa fa-plus"></i></button>
                <button class="btn btn-box-tool" data-widget="remove" data-toggle="tooltip" title="Remove"><i class="fa fa-times"></i></button>
            </div>
        </div>
        <div class="box-body">           
            <table id="example" class="table table-hover table-bordered nowrap" style="width:100%">
                <thead>
                    <tr style="color: #fff; background: #3498db;">
                        <th>No</th>
                        <th>No. ID</th>
                        <th>Nama</th>
                        <th>Status</th>
                        <th>IP Address</th>
                        <th>Browser</th>
                        <th>OS</th>
                        <th>AKTIF</th>
                        <th>Waktu</th>
                    </tr>
                </thead>
                <tbody>
                    <?php
                    $login = mysql_query("SELECT * FROM rb_users_aktivitas ORDER BY id_users_aktivitas DESC limit 30");
                    $no = 1;
                    while ($row = mysql_fetch_array($login)) {
                        if ($row['status'] == 'siswa') {
                            $cek = mysql_fetch_array(mysql_query("SELECT * FROM rb_siswa where nisn='$row[identitas]'"));
                            $nama_user = $cek['nama'];
                        } elseif ($row['status'] == 'guru' OR $row['status'] == 'kepala') {
                            $cek = mysql_fetch_array(mysql_query("SELECT * FROM rb_guru where nip='$row[identitas]'"));
                            $nama_user = $cek['nama_guru'];
                        } else {
                            $cek = mysql_fetch_array(mysql_query("SELECT * FROM rb_users where id_user='$row[identitas]'"));
                            $nama_user = $cek['nama_lengkap'];
                        }
                        echo "<tr>
                                    <th>$no</th>
                                    <td><span class='badge badge-info'>$row[identitas]</span></td>
                                    <td>$row[nama]</td>
                                    <td>$row[status]</td>
                                    <td>$row[ip_address]</td>
                                    <td><span class='badge badge-success'>$row[browser]</span></td>
                                    <td><span class='badge badge-warning'>$row[os]</span></td>
                                    <td class='text-success'><i>" . cek_terakhir($row['tanggal'] . ' ' . $row['jam']) . "</i></td>
                                    <td>$row[jam] $row[tanggal]</td>
                                </tr>";
                        $no++;
                    }
                    ?>
                </tbody>
            </table>            
        </div>
    </div>
</div>